=== git-annex-5.20150317/debian/rules ===
#!/usr/bin/make -f

export CABAL=debian/cabal-wrapper

# Do use the changelog's version number, rather than making one up.
export RELEASE_BUILD=1

%:
	dh $@
